/*
	LAMEpXNvg
	g̏ڍׂ̓eLXgt@Cׂ
*/

// -------------------------------------------------------------------------------------------------
var version = "ver. 1.1"; // o[W
var default_title = "LAMEpXNvg " + version;
var default_inifile = "lame.ini"; // ftHginit@C

// ȉiniŐݒłϐ
var option = ""; // option
var command_line = "lame %option% %in% %out%"; // R}hC
var reload_input = 1; // inputtH_ǂݒǂ̃tO
var thread_max = 1; // N鐔
var output_copy = false; // o̓t@C̓Rs[ĕۑ
var check_interval = 1000; // (msec) vZXĎ̊Ԋu
var remove_empty_folder = true; // inputtH_̋tH_폜
var hide_cmd_window = false; // R}hvvg\ɂ邩
var input_extension = /\.(?:mp3|wav)$/i; // GR[ht@C̊gq
var output_extension = "mp3"; // o̓t@C̊gq
var write_log = true; // Ocǂ
var log_file = "lame.log"; // Ot@C


// -------------------------------------------------------------------------------------------------
var Shell = new ActiveXObject("WScript.Shell");
var FSO = new ActiveXObject("Scripting.FileSystemObject");
Shell.CurrentDirectory = WScript.ScriptFullName.replace(/[^\\]*$/, "");


if (WScript.Arguments.Named.Exists("child")) {
	// child mode
	var command = unescape( WScript.Arguments.Named.Item("child") );
	var window_style = WScript.Arguments.Named.Exists("h") ? 0:10;
	var exit_code = -1;
	try {
		exit_code = Shell.Run(command, window_style, true);
	} catch (err) {}
	WScript.Quit( exit_code );
}


var msg = new MessageFile("message.dat");
var LF = new LockFile("lock.dat");
if (!LF.lock()) { // lame.js N
	var popup_ret = popup_YesNo("݂̃t@CŃGR[h𒆒f܂H", "f̊mF");
	if (popup_ret==6) msg.post("exit"); // yes
	WScript.Quit();
}

// init@C̓ǂݍ
var ini_path = default_inifile;
if (WScript.Arguments.length==1 && /\.ini$/i.test(WScript.Arguments.Item(0))) {
	ini_path = WScript.Arguments.Item(0);
}
var iniObj = new IniFileReader( ini_path );
if (iniObj.fileExists()) {
	iniObj.load();
	option = iniObj.get("lame", "option", option);
	command_line = iniObj.get("lame", "command_line", command_line);
	reload_input = toInt( iniObj.get("lame", "reload_input", reload_input) );
	thread_max = toInt( iniObj.get("lame", "thread_max", thread_max) );
	output_copy = toBool( iniObj.get("lame", "output_copy", output_copy) );
	check_interval = toInt( iniObj.get("lame", "check_interval", check_interval) );
	remove_empty_folder = toBool( iniObj.get("lame", "remove_empty_folder", remove_empty_folder) );
	hide_cmd_window = toBool( iniObj.get("lame", "hide_cmd_window", hide_cmd_window) );
	if (iniObj.exists("lame", "input_extension")) {
		var ext = iniObj.get("lame", "input_extension", "").replace(/,/g, "|");
		try {
			input_extension = new RegExp( "\\.(?:"+ext+")$", "i" );
		} catch(err) {}
	}
	output_extension = iniObj.get("lame", "output_extension", output_extension);
	write_log = toBool( iniObj.get("lame", "write_log", write_log) );
	log_file = iniObj.get("lame", "log_file", log_file);
}
iniObj = null;


var timer = new TimeChecker;
var log_obj = new LogFile( log_file );
// bZ[Wt@CȂ
msg.initFile();
timer.start();
log_obj.writeln("***** START "+ dateToYMDHMS(new Date) +" *****");
ini_path = ini_path.replace(Shell.CurrentDirectory+"\\", "");
if (ini_path!=default_inifile) log_obj.writeln("[ini] "+ ini_path);

var lame_objs = new Array;
var id = 0;
var encoded_count = 0, error_count = 0;

var exit_flag = false;
var iFiles = loadFilenames("input", true);
var skipFiles = new Array;

while (iFiles.length!=0 || lame_objs.length!=0) {
	// execute new process
	while (iFiles.length > 0 && lame_objs.length < thread_max && !exit_flag) {
		var file = iFiles.shift();
		var obj = new Lame( file, id++ );
		if (obj.setInput()) {
			obj.execute();
			lame_objs.push( obj );
		} else {
			log_obj.writeln( file +"\t"+ obj.getLastError() );
			skipFiles.push( file );
			error_count++;
		}
	}
	
	WScript.Sleep( check_interval );
	
	var reload_flag = (reload_input==2);
	// check state
	for (var i=0; i<lame_objs.length; i++) {
		var obj = lame_objs[i];
		if (!obj.isRunning()) {
			var eCode = obj.getExitCode();
			if (eCode==0) {
				// success
				var iPath = obj.getInputPath();
				var oMove = output_copy ? obj.moveOutputWithCopy() : obj.moveOutput();
				if (!oMove || !obj.moveInput()) {
					log_obj.writeln( iPath +"\t"+ obj.getLastError() );
					obj.moveInputToError();
					error_count++;
				} else {
					log_obj.writeln( iPath +"\t(OK)" );
					encoded_count++;
				}
			} else {
				// error
				log_obj.writeln( obj.getInputPath() +"\tɏI܂ł(IR[h:"+ eCode +")" );
				obj.moveInputToError();
				error_count++;
			}
			// iԖڂ폜
			// Ԃɂ͂܂ӖȂ
			lame_objs[i] = lame_objs[ lame_objs.length-1 ];
			lame_objs.pop();
			
			if (reload_input==1) reload_flag = true;
		}
	}
	
	// get message
	var msg_str = msg.get();
	if (msg_str == "exit") {
		iFiles.length = 0;
		exit_flag = true;
	}
	
	// watch input folder
	// Ԃێ
	if (reload_flag && !exit_flag) {
		var new_iFiles = loadFilenames("input", true);
		// remove skip files / iFiles
		var remFiles = skipFiles.concat( iFiles );
		for (var i=0; i<remFiles.length; i++) {
			for (var j=0; j<new_iFiles.length; j++) {
				if (new_iFiles[j]==remFiles[i]) {
					new_iFiles = new_iFiles.slice(0, j).concat( new_iFiles.slice(j+1) );
					break;
				}
			}
		}
		iFiles = iFiles.concat( new_iFiles );
	}
}

if (remove_empty_folder) removeEmptyInputFolder();
timer.end();
//log_obj.writeln("[time] "+ timer.getTimeString(1));
log_obj.writeln("*****  END  "+ dateToYMDHMS(new Date) +" *****");
log_obj.writeln("");
msg.removeFile();
LF.unlock();


var mes;
if (encoded_count+error_count==0 && !exit_flag) {
	mes = "inputtH_ɃGR[ht@CĂB";
} else {
	mes = (!exit_flag) ? "I܂B\n" : "f܂B\n";
	mes += "Result:\n";
	mes += "  "+ encoded_count +" files encoded.\n";
	if (error_count!=0) mes += "  "+ error_count +" files error!\n";
	mes += "  "+ timer.getTimeString(1) +"\n";
}

echo( mes );


// -------------------------------------------------------------------------------------------------
function removeEmptyInputFolder(){
	try { var inp = FSO.GetFolder("input"); } catch (err) { return; }
	var fols = new Enumerator( inp.SubFolders );
	while (!fols.atEnd()) {
		check( fols.item() );
		fols.moveNext();
	}
	return;
	
	// local
	function check(folObj){
		var subfol = new Enumerator( folObj.SubFolders );
		while (!subfol.atEnd()) {
			check(subfol.item());
			subfol.moveNext();
		}
		subfol = new Enumerator( folObj.SubFolders );
		var files = new Enumerator( folObj.Files );
		if (subfol.atEnd() && files.atEnd()) folObj.Delete();
	}
}

function loadFilenames( path, read_sub ){
	var arr = new Array;
	try {
		var fol = FSO.GetFolder(path);
		enumFiles( fol, "" );
	} catch (err) {}
	return arr;
	
	// local
	function enumFiles(folObj, relPath){
		if (read_sub) {
			var subfol = new Enumerator( folObj.SubFolders );
			while (!subfol.atEnd()) {
				var item = subfol.item();
				enumFiles(item, relPath+item.Name+"\\");
				subfol.moveNext();
			}
		}
		var files = new Enumerator( folObj.Files );
		while (!files.atEnd()) {
			var name = files.item().Name;
			if (input_extension.test(name)) arr.push(relPath+name);
			files.moveNext();
		}
	}
}

// -------------------------------------------------------------------------------------------------
function Lame( path_by_input, id ){
	var folderPath, inputName;
	if (/\\([^\\]+)$/.test(path_by_input)) {
		folderPath = RegExp.leftContext;
		inputName = RegExp.$1;
	} else {
		folderPath = "";
		inputName = path_by_input;
	}
	var short_name, ext;
	if (/\.([^\.]+)$/.test(inputName)) {
		short_name = RegExp.leftContext;
		ext = "."+ RegExp.$1;
	} else {
		short_name = inputName;
		ext = "";
	}
	var iTempName = "input_"+ id + ext;
	var oTempName = "output_"+ id +"."+ output_extension;
	var outputName = short_name +"."+ output_extension;
	
	var exec_obj = null;
	var error_log = "";
	
	this.setInput = setInput;
	this.moveInput = moveInput;
	this.restoreInput = restoreInput;
	this.moveInputToError = moveInputToError;
	this.removeInput = removeInput;
	
	this.execute = execute;
	this.isRunning = isRunning;
	this.getExitCode = getExitCode;
	
	this.moveOutput = moveOutput;
	this.moveOutputWithCopy = moveOutputWithCopy;
	this.removeOutput = removeOutput;
	
	this.getLastError = getLastError;
	this.getInputPath = getInputPath;
	return this;
	
	// input
	function setInput(){
		if (FSO.FileExists(iTempName) && !remove(iTempName)) return false;
		var inputPath = mkpath("input", folderPath, inputName);
		return move(inputPath, iTempName);
	}
	// function setInputWithCopy(){}
	function moveInput(){
		var encodedFolder = mkpath("encoded", folderPath);
		var encodedPath = mkpath(encodedFolder, inputName);
		return mkdir(encodedFolder) && move(iTempName, encodedPath, 10);
	}
	function restoreInput(){
		var inputPath = mkpath("input", folderPath, inputName);
		return move( iTempName, inputPath, 10 );
	}
	function moveInputToError(){
		var errorFolder = mkpath("error", folderPath);
		var errorPath = mkpath(errorFolder, inputName);
		return mkdir(errorFolder) && move(iTempName, errorPath, 10);
	}
	function removeInput(){
		return remove(iTempName);
	}
	
	// exec
	function execute(){
		var lame_command = "", comstr = command_line;
		while (/%(\w*)%/.test(comstr)) {
			comstr = RegExp.rightContext;
			lame_command += RegExp.leftContext;
			switch (RegExp.$1.toLowerCase()) {
			case "option": lame_command += option; break;
			case "in":  lame_command += iTempName; break;
			case "out": lame_command += oTempName; break;
			case "":    lame_command += "%"; break;
			default:    lame_command += RegExp.$1; break;
			}
		}
		lame_command += comstr;
		
		var command = "WScript "+ WScript.ScriptName +" /child:"+ escape(lame_command);
		if (hide_cmd_window) command += " /h";
		exec_obj = Shell.Exec( command );
	}
	function isRunning(){
		return exec_obj && exec_obj.Status==0;
	}
	function getExitCode(){
		return (exec_obj && exec_obj.Status==1) ? exec_obj.ExitCode : 0;
	}
	
	// output
	function moveOutput(){
		var outputFolder = mkpath("output", folderPath);
		var outputPath = mkpath(outputFolder, outputName);
		return mkdir(outputFolder) && move(oTempName, outputPath, 10);
	}
	function moveOutputWithCopy(){
		var outputFolder = mkpath("output", folderPath);
		var outputPath = mkpath(outputFolder, outputName);
		return mkdir(outputFolder) && copy(oTempName, outputPath, 10) && removeOutput();
	}
	function removeOutput(){
		return remove(oTempName);
	}
	
	function getLastError(){
		return error_log;
	}
	function getInputPath(){
		return path_by_input;
	}
	
	// local
	function mkpath(){ // mkpath(...)
		var path = arguments[0];
		for (var i=1; i<arguments.length; i++) {
			path = FSO.BuildPath(path, arguments[i]);
		}
		return path;
	}
	function mkdir(dirPath){
		try {
			if (!FSO.FolderExists(dirPath)) {
				var arr = dirPath.split("\\");
				for (var i=0; i<arr.length; i++) {
					var path = arr.slice(0,i+1).join("\\");
					if (!FSO.FolderExists(path)) FSO.CreateFolder(path);
				}
			}
		} catch(err) {
			error_log = err.message;
			return false;
		}
		return true;
	}
	function move( old_path, new_path, retry ){
		try {
			FSO.MoveFile( old_path, new_path );
			error_log = new_path;
		} catch (err) {
			if (retry && /([^\\]+)$/.test(new_path)) {
				return move(old_path, RegExp.leftContext+"_"+RegExp.$1, retry-1);
			} else {
				error_log = "t@Cړł܂("+ old_path +" -> "+ new_path +")";
				return false;
			}
		}
		return true;
	}
	function copy( src_path, new_path, retry ){
		try {
			FSO.CopyFile( src_path, new_path );
			error_log = new_path;
		} catch (err) {
			if (retry && /([^\\]+)$/.test(new_path)) {
				return copy(old_path, RegExp.leftContext+"_"+RegExp.$1, retry-1);
			} else {
				error_log = "t@CRs[ł܂("+ old_path +" -> "+ new_path +")";
				return false;
			}
		}
		return true;
	}
	function remove( path ){
		try {
			FSO.DeleteFile( path );
			error_log = path;
		} catch (err) {
			error_log = "t@C폜ł܂("+ path +")";
			return false;
		}
		return true;
	}
}

// -------------------------------------------------------------------------------------------------
function LockFile( fpath ){
	var F = null;
	this.lock = lock;
	this.unlock = unlock;
	return this;
	
	function lock(){
		if (F!==null) return false;
		try {
			F = FSO.OpenTextFile( fpath, 2, true );
		} catch (err) {
			return false;
		}
		return true;
	}
	function unlock(){
		try {
			F.Close();
			F = null;
		} catch (err) {
			return false;
		}
		try {
			// ق̃vZXbNĂ邩Ȃ̂ŁA폜łȂĂ
			FSO.DeleteFile( fpath );
		} catch (err) {}
		return true;
	}
}

function MessageFile( fname ){
	var F = null;
	var cache = "";
	this.wait_interval = 200;
	
	this.initFile = initFile;
	this.post = post;
	this.get = get;
	this.close = close;
	this.removeFile = removeFile;
	return this;
	
	function initFile(){
		if (FSO.FileExists(fname)) {
			var file = fileOpen(2, this.wait_interval);
			file.Close();
		}
	}
	function post( message ){
		var out = fileOpen(8, this.wait_interval);
		out.WriteLine( message );
		out.Close();
	}
	function get(){
		if (!F && FSO.FileExists(fname)) F = fileOpen(1, 0);
		if (F && !F.AtEndOfStream) cache += F.ReadAll();
		if (/^(.+)\r\n/.test(cache)) {
			cache = RegExp.rightContext;
			return RegExp.$1;
		}
		return "";
	}
	function close(){
		if (F) { F.close(); F = null; }
	}
	function removeFile(){
		close();
		try { FSO.DeleteFile( fname ); } catch(e) { return false; }
		return true;
	}
	
	// local
	function fileOpen( mode, retry_interval ){
		if (!(retry_interval > 0)) retry_interval = 0;
		var F = null;
		do {
			try {
				F = FSO.OpenTextFile( fname, mode, true );
			} catch (e) {
				if (retry_interval) WScript.Sleep(retry_interval);
				else break;
			}
		} while (!F);
		return F;
	}
}

function IniFileReader( path ){
	var data;
	this.fileExists = fileExists;
	this.load = load;
	this.exists = exists;
	this.get = get;
	return this;
	
	function fileExists(){
		return FSO.FileExists(path);
	}
	function load(){
		data = new Object;
		var section = "_";
		var ini = FSO.OpenTextFile(path, 1);
		while (!ini.AtEndOfStream) {
			var line = ini.ReadLine();
			if (/^\s*;/.test(line)) {
				continue;
			} else if (/^\[(.+)\]$/.test(line)) {
				section = RegExp.$1;
			} else if (/=/.test(line)) {
				if (!(section in data)) data[section] = new Object;
				data[section][RegExp.leftContext] = RegExp.rightContext;
			}
		}
		ini.Close();
	}
	function exists( section, key ){
		return (section in data) && (key in data[section]);
	}
	function get( section, key, default_value ){
		return exists(section, key) ? data[section][key] : default_value;
	}
}

function TimeChecker(){
	var bef = NaN, aft = NaN;
	this.start = start;
	this.end = end;
	this.getTimeString = getTimeString;
	return this;
	
	function start(){ bef = new Date; }
	function end(){ aft = new Date; }
	function getTime(type, dec){
		if (!(type>=0 && type<=3)) type = 0;
		if (!dec) dec = 0;
		var dev = [1, 1000, 1000*60, 1000*60*60][type];
		var msec = aft.getTime() - bef.getTime();
		var scale = Math.pow(10, dec);
		return Math.round((msec/dev)*scale)/scale;
	}
	function getTimeString(type, dec){
		if (!bef || !aft) return "0";
		if (!(type>=0 && type<=3)) type = 0;
		var str = ["msec", "sec", "min", "h"];
		return getTime(type, dec) + " "+ str[type];
	}
}

function LogFile( fname ){
	this.write = write;
	this.writeln = writeln;
	return this;
	
	function write( str ){
		if (!write_log) return false;
		try {
			var F = FSO.OpenTextFile(fname, 8, true);
			F.Write( str );
			F.Close();
		} catch (e) { return false; }
		return true;
	}
	function writeln( str ){ return write(str+"\r\n"); }
}

// -------------------------------------------------------------------------------------------------
function toInt( str ){
	return parseInt( str, 10 );
}
function toBool( b ){
	if (!b) return false;
	var str = String(b).toLowerCase();
	return (str!="false" && str!="0");
}
function intToStr( n, len ){
	return String(n+Math.pow(10,len)).slice(-len);
}
function dateToYMDHMS( dt ){
	var its = intToStr;
	var ymd = [ its(dt.getFullYear(),4), its(dt.getMonth()+1,2), its(dt.getDate(),2) ];
	var hms = [ its(dt.getHours(),2), its(dt.getMinutes(),2), its(dt.getSeconds(),2) ];
	return ymd.join("/") +" "+ hms.join(":");
}

// -------------------------------------------------------------------------------------------------
function trace( mes, title ){
	if (!title) title = default_title;
	Shell.Popup( mes, 30, title, 64 );
}
function echo( mes, title ){
	if (!title) title = default_title;
	Shell.Popup( mes, 0, title, 64 );
}
function popup_YesNo( mes, title ){
	if (!title) title = default_title;
	return Shell.Popup( mes, 30, title, 32+4 );
	// Yes: 6, No: 7, timeout: -1
}
function popup_YesNoCancel( mes, title ){
	if (!title) title = default_title;
	return Shell.Popup( mes, 30, title, 32+3 );
	// Yes: 6, No: 7, cancel: 2, timeout: -1
}

